﻿
#include <iostream>
#include <string>
#include <conio.h>

using namespace std;

class Edit
{
	string data;

public:
	virtual bool validate(char c)
	{
		return isdigit(c);
	}
	string getData()
	{
		data.clear();
		
		while (1)
		{
			// 한글자 입력 받기
			char c = _getch();
			// Enter Key > 입력 완료
			if (c == 13) break;

			// 입력 유효성 검사 (정책)
			if (validate(c))
			{
				// 유효한 문자만 저장
				data.push_back(c);
				cout << c;
			}
		}
		// 개행하고 끝내기
		cout << endl;
		return data;
	}

};

class AddressEdit : public Edit
{
	// 주소는 모든 문자를 허용해야함.
	virtual bool validate(char c)
	{
		return true;
	}
};

int main()
{
	//Edit edit;
	AddressEdit addEdit;
	while (1)
	{
		string s = addEdit.getData();
		cout << s << endl;
	}

}

/**
* 이런 getData 같은 코드들은 라이브러리 내부에 있을텐데? 코드가 변경되면 안되고 정책은 변경할 수 있어야한다.
* -> Validation정책을 교채하는 두가지 패턴.
* 변하지 않는 코드(전체 흐츰) 안에 변해야하는 부분(정책)은 분리하는 것이 옳다.
* 
* @ 변해야하는 부분(Validation 정책)을 별도의 가상함수로 분리한다.
*   -> Template Method 기법
*/